using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace GDBGIsModified
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(0, 0);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(480, 266);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 266);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		#region DataTables

		private int numberParentRows = 50;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			
			

			dt.Columns.Add(new DataColumn("Date",typeof(DateTime)));
			dt.Columns.Add(new DataColumn("Check1",typeof(bool)));
			dt.Columns.Add(new DataColumn("Check2",typeof(bool)));
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("desc{0}", i);
				dr[3] = DateTime.Now; 
				dr[4] = false;
				dr[5] = true;
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			dt.Columns.Add(new DataColumn("other")); //upper case P
			dt.Columns.Add(new DataColumn("otherx")); //upper case P
			for(int i = 0;i < 5;i++)
				dt.Columns.Add(); 
			
			for(int i = 0; i < numberChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dr[3] = string.Format("other{0}",i);
				dr[4] = string.Format("otherx{0}",i);

				for(int j = 5;j < 9;j++)
				{
					dr[j] = "Column" + j;
				}
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		
		#endregion

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.DataSource = GetParentTable(); 

			this.gridDataBoundGrid1.EnableAddNew = true; 
			this.gridDataBoundGrid1.Binder.EnableAddNew = true; 
			
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.Binder.BindingListChanged +=new ListChangedEventHandler(Binder_BindingListChanged);  

		}

	

		private void Binder_BindingListChanged(object sender, ListChangedEventArgs e)
		{
			if( e.ListChangedType == ListChangedType.ItemChanged )
			{
				GridModelDataBinder binder = sender as GridModelDataBinder;
				DataTable dt = binder.DataSource as DataTable; 
				foreach(DataColumn column in dt.Columns) 
				Console.Write( column.ColumnName + " ---> " + dt.Rows[e.NewIndex][column.ColumnName] + "  " ); 
			}
		}
	}
}
